Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1933)
@@ -1,5 +1,5 @@
 MODULE pmc_interface
 
-!------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 ! This file is part of PALM.
 !
@@ -16,5 +16,5 @@
 !
 ! Copyright 1997-2016 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -26,6 +26,7 @@
 ! $Id$
 !
-! 1927 2016-06-07 11:56:53Z hellstea
-! Error check for overlapping parallel nests added 
+! 1901 2016-05-04 15:39:38Z raasch
+! Initial version of purely vertical nesting introduced.
+! Code clean up. The words server/client changed to parent/child.
 !
 ! 1900 2016-05-04 15:27:53Z raasch
@@ -62,5 +63,5 @@
 ! introduction of different datatransfer modes,
 ! further formatting cleanup, parameter checks added (including mismatches
-! between root and client model settings),
+! between root and nest model settings),
 ! +routine pmci_check_setting_mismatches
 ! comm_world_nesting introduced
@@ -106,32 +107,32 @@
 ! Domain nesting interface routines. The low-level inter-domain communication   
 ! is conducted by the PMC-library routines.
-!------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 
 #if defined( __nopointer )
-    USE arrays_3d,                                                             &
-        ONLY:  dzu, dzw, e, e_p, pt, pt_p, q, q_p, u, u_p, v, v_p, w, w_p, zu, &
+    USE arrays_3d,                                                              &
+        ONLY:  dzu, dzw, e, e_p, pt, pt_p, q, q_p, u, u_p, v, v_p, w, w_p, zu,  &
                zw, z0
 #else
-   USE arrays_3d,                                                              &
-        ONLY:  dzu, dzw, e, e_p, e_1, e_2, pt, pt_p, pt_1, pt_2, q, q_p, q_1,  &
-               q_2, u, u_p, u_1, u_2, v, v_p, v_1, v_2, w, w_p, w_1, w_2, zu,  &
+   USE arrays_3d,                                                               &
+        ONLY:  dzu, dzw, e, e_p, e_1, e_2, pt, pt_p, pt_1, pt_2, q, q_p, q_1,   &
+               q_2, u, u_p, u_1, u_2, v, v_p, v_1, v_2, w, w_p, w_1, w_2, zu,   &
                zw, z0
 #endif
 
-    USE control_parameters,                                                    &
-        ONLY:  coupling_char, dt_3d, dz, humidity, message_string,             &
-               nest_bound_l, nest_bound_r, nest_bound_s, nest_bound_n,         &
-               nest_domain, neutral, passive_scalar, simulated_time,           &
+    USE control_parameters,                                                     &
+        ONLY:  coupling_char, dt_3d, dz, humidity, message_string,              &
+               nest_bound_l, nest_bound_r, nest_bound_s, nest_bound_n,          &
+               nest_domain, neutral, passive_scalar, simulated_time,            &
                topography, volume_flow
 
-    USE cpulog,                                                                &
+    USE cpulog,                                                                 &
         ONLY:  cpu_log, log_point_s
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                         &
         ONLY:  dx, dy
 
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nyn, nyng, nys, nysg, &
-               nysv, nz, nzb, nzb_s_inner, nzb_u_inner, nzb_u_outer,           &
+    USE indices,                                                                &
+        ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nyn, nyng, nys, nysg,  &
+               nysv, nz, nzb, nzb_s_inner, nzb_u_inner, nzb_u_outer,            &
                nzb_v_inner, nzb_v_outer, nzb_w_inner, nzb_w_outer, nzt
 
@@ -145,29 +146,29 @@
 #endif
 
-    USE pegrid,                                                                &
-        ONLY:  collective_wait, comm1dx, comm1dy, comm2d, myid, myidx, myidy,  &
+    USE pegrid,                                                                 &
+        ONLY:  collective_wait, comm1dx, comm1dy, comm2d, myid, myidx, myidy,   &
                numprocs
 
-    USE pmc_client,                                                            &
-        ONLY:  pmc_clientinit, pmc_c_clear_next_array_list,                    &
-               pmc_c_getnextarray, pmc_c_get_2d_index_list, pmc_c_getbuffer,   &
-               pmc_c_putbuffer, pmc_c_setind_and_allocmem,                     &
+    USE pmc_child,                                                              &
+        ONLY:  pmc_childinit, pmc_c_clear_next_array_list,                      &
+               pmc_c_getnextarray, pmc_c_get_2d_index_list, pmc_c_getbuffer,    &
+               pmc_c_putbuffer, pmc_c_setind_and_allocmem,                      &
                pmc_c_set_dataarray, pmc_set_dataarray_name
 
-    USE pmc_general,                                                           &
+    USE pmc_general,                                                            &
         ONLY:  da_namelen
 
-    USE pmc_handle_communicator,                                               &
-        ONLY:  pmc_get_model_info, pmc_init_model, pmc_is_rootmodel,           &
-               pmc_no_namelist_found, pmc_server_for_client
-
-    USE pmc_mpi_wrapper,                                                       &
-        ONLY:  pmc_bcast, pmc_recv_from_client, pmc_recv_from_server,          &
-               pmc_send_to_client, pmc_send_to_server
-
-    USE pmc_server,                                                            &
-        ONLY:  pmc_serverinit, pmc_s_clear_next_array_list, pmc_s_fillbuffer,  &
-               pmc_s_getdata_from_buffer, pmc_s_getnextarray,                  &
-               pmc_s_setind_and_allocmem, pmc_s_set_active_data_array,         &
+    USE pmc_handle_communicator,                                                &
+        ONLY:  pmc_get_model_info, pmc_init_model, pmc_is_rootmodel,            &
+               pmc_no_namelist_found, pmc_parent_for_child
+
+    USE pmc_mpi_wrapper,                                                        &
+        ONLY:  pmc_bcast, pmc_recv_from_child, pmc_recv_from_parent,            &
+               pmc_send_to_child, pmc_send_to_parent
+
+    USE pmc_parent,                                                             &
+        ONLY:  pmc_parentinit, pmc_s_clear_next_array_list, pmc_s_fillbuffer,   &
+               pmc_s_getdata_from_buffer, pmc_s_getnextarray,                   &
+               pmc_s_setind_and_allocmem, pmc_s_set_active_data_array,          &
                pmc_s_set_dataarray, pmc_s_set_2d_index_list
 
@@ -180,6 +181,6 @@
 !
 !-- Constants
-    INTEGER(iwp), PARAMETER ::  client_to_server = 2   !:
-    INTEGER(iwp), PARAMETER ::  server_to_client = 1   !:
+    INTEGER(iwp), PARAMETER ::  child_to_parent = 2   !:
+    INTEGER(iwp), PARAMETER ::  parent_to_child = 1   !:
 
 !
@@ -196,5 +197,5 @@
                                                          !: parameter for data-
                                                          !: transfer mode
-    CHARACTER(LEN=7), SAVE ::  nesting_mode = 'two-way'  !: steering parameter
+    CHARACTER(LEN=8), SAVE ::  nesting_mode = 'two-way'  !: steering parameter
                                                          !: for 1- or 2-way nesting
 
@@ -216,5 +217,5 @@
 
 !
-!-- Client coarse data arrays
+!-- Child coarse data arrays
     INTEGER(iwp), DIMENSION(5)                  ::  coarse_bound   !:
 
@@ -237,6 +238,6 @@
 
 !
-!-- Client interpolation coefficients and client-array indices to be precomputed
-!-- and stored.
+!-- Child interpolation coefficients and child-array indices to be 
+!-- precomputed and stored.
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ico    !:
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  icu    !:
@@ -259,5 +260,5 @@
 
 !
-!-- Client index arrays and log-ratio arrays for the log-law near-wall
+!-- Child index arrays and log-ratio arrays for the log-law near-wall
 !-- corrections. These are not truly 3-D arrays but multiple 2-D arrays.
     INTEGER(iwp), SAVE :: ncorr  !: 4th dimension of the log_ratio-arrays
@@ -313,5 +314,5 @@
 
 !
-!-- Client-array indices to be precomputed and stored for anterpolation.
+!-- Child-array indices to be precomputed and stored for anterpolation.
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflu   !:
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuu   !:
@@ -363,6 +364,6 @@
     END INTERFACE
 
-    INTERFACE pmci_client_initialize
-       MODULE PROCEDURE pmci_client_initialize
+    INTERFACE pmci_child_initialize
+       MODULE PROCEDURE pmci_child_initialize
     END INTERFACE
 
@@ -387,6 +388,6 @@
     END INTERFACE
 
-    INTERFACE pmci_server_initialize
-       MODULE PROCEDURE pmci_server_initialize
+    INTERFACE pmci_parent_initialize
+       MODULE PROCEDURE pmci_parent_initialize
     END INTERFACE
 
@@ -395,15 +396,15 @@
     END INTERFACE pmci_set_swaplevel
 
-    PUBLIC anterp_relax_length_l, anterp_relax_length_r,                       &
-           anterp_relax_length_s, anterp_relax_length_n,                       &
-           anterp_relax_length_t, client_to_server, comm_world_nesting,        &
-           cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,        &
-           server_to_client
-    PUBLIC pmci_client_initialize
+    PUBLIC anterp_relax_length_l, anterp_relax_length_r,                        &
+           anterp_relax_length_s, anterp_relax_length_n,                        &
+           anterp_relax_length_t, child_to_parent, comm_world_nesting,          &
+           cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,         &
+           parent_to_child
+    PUBLIC pmci_child_initialize
     PUBLIC pmci_datatrans
     PUBLIC pmci_ensure_nest_mass_conservation
     PUBLIC pmci_init
     PUBLIC pmci_modelconfiguration
-    PUBLIC pmci_server_initialize
+    PUBLIC pmci_parent_initialize
     PUBLIC pmci_synchronize
     PUBLIC pmci_set_swaplevel
@@ -415,5 +416,5 @@
  SUBROUTINE pmci_init( world_comm )
 
-    USE control_parameters,                                                  &
+    USE control_parameters,                                                     &
         ONLY:  message_string
 
@@ -429,5 +430,5 @@
 
 
-    CALL pmc_init_model( world_comm, nesting_datatransfer_mode, nesting_mode,  &
+    CALL pmc_init_model( world_comm, nesting_datatransfer_mode, nesting_mode,   &
                          pmc_status )
 
@@ -445,6 +446,7 @@
 !
 !-- Check steering parameter values
-    IF ( TRIM( nesting_mode ) /= 'one-way'  .AND.                              &
-         TRIM( nesting_mode ) /= 'two-way' )                                   &
+    IF ( TRIM( nesting_mode ) /= 'one-way'  .AND.                               &
+         TRIM( nesting_mode ) /= 'two-way'  .AND.                               &
+         TRIM( nesting_mode ) /= 'vertical' )                                   &                 
     THEN
        message_string = 'illegal nesting mode: ' // TRIM( nesting_mode )
@@ -452,9 +454,9 @@
     ENDIF
 
-    IF ( TRIM( nesting_datatransfer_mode ) /= 'cascade'  .AND.                 &
-         TRIM( nesting_datatransfer_mode ) /= 'mixed'    .AND.                 &
-         TRIM( nesting_datatransfer_mode ) /= 'overlap' )                      &
+    IF ( TRIM( nesting_datatransfer_mode ) /= 'cascade'  .AND.                  &
+         TRIM( nesting_datatransfer_mode ) /= 'mixed'    .AND.                  &
+         TRIM( nesting_datatransfer_mode ) /= 'overlap' )                       &
     THEN
-       message_string = 'illegal nesting datatransfer mode: '                  &
+       message_string = 'illegal nesting datatransfer mode: '                   &
                         // TRIM( nesting_datatransfer_mode )
        CALL message( 'pmci_init', 'PA0418', 3, 2, 0, 6, 0 )
@@ -468,8 +470,8 @@
 !-- Get some variables required by the pmc-interface (and in some cases in the
 !-- PALM code out of the pmci) out of the pmc-core
-    CALL pmc_get_model_info( comm_world_nesting = comm_world_nesting,          &
-                             cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,   &
-                             cpl_name = cpl_name, npe_total = cpl_npe_total,   &
-                             lower_left_x = lower_left_coord_x,                &
+    CALL pmc_get_model_info( comm_world_nesting = comm_world_nesting,           &
+                             cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,    &
+                             cpl_name = cpl_name, npe_total = cpl_npe_total,    &
+                             lower_left_x = lower_left_coord_x,                 &
                              lower_left_y = lower_left_coord_y )
 !
@@ -513,12 +515,12 @@
     CALL pmci_setup_coordinates
 !
-!-- Initialize the client (must be called before pmc_setup_server)
-    CALL pmci_setup_client
-!
-!-- Initialize PMC Server
-    CALL pmci_setup_server
-!
-!-- Check for mismatches between settings of master and client variables
-!-- (e.g., all clients have to follow the end_time settings of the root master)
+!-- Initialize the child (must be called before pmc_setup_parent)
+    CALL pmci_setup_child
+!
+!-- Initialize PMC parent
+    CALL pmci_setup_parent
+!
+!-- Check for mismatches between settings of master and child variables
+!-- (e.g., all children have to follow the end_time settings of the root master)
     CALL pmci_check_setting_mismatches
 
@@ -529,5 +531,5 @@
 
 
- SUBROUTINE pmci_setup_server
+ SUBROUTINE pmci_setup_parent
 
 #if defined( __parallel )
@@ -536,5 +538,5 @@
     CHARACTER(LEN=32) ::  myname
 
-    INTEGER(iwp) ::  client_id        !:
+    INTEGER(iwp) ::  child_id         !:
     INTEGER(iwp) ::  ierr             !:
     INTEGER(iwp) ::  i                !:
@@ -558,4 +560,8 @@
     REAL(wp) ::  dx_cl            !:
     REAL(wp) ::  dy_cl            !:
+    REAL(wp) ::  left_limit       !:
+    REAL(wp) ::  north_limit      !:
+    REAL(wp) ::  right_limit      !:
+    REAL(wp) ::  south_limit      !:
     REAL(wp) ::  xez              !:
     REAL(wp) ::  yez              !:
@@ -568,25 +574,25 @@
 
 !
-!   Initialize the pmc server
-    CALL pmc_serverinit
+!   Initialize the pmc parent
+    CALL pmc_parentinit
 
 !
 !-- Corners of all children of the present parent
-    IF ( ( SIZE( pmc_server_for_client ) - 1 > 0 ) .AND. myid == 0 )  THEN 
-       ALLOCATE( ch_xl(1:SIZE( pmc_server_for_client ) - 1) )
-       ALLOCATE( ch_xr(1:SIZE( pmc_server_for_client ) - 1) )
-       ALLOCATE( ch_ys(1:SIZE( pmc_server_for_client ) - 1) )
-       ALLOCATE( ch_yn(1:SIZE( pmc_server_for_client ) - 1) )
+    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) .AND. myid == 0 )  THEN 
+       ALLOCATE( ch_xl(1:SIZE( pmc_parent_for_child ) - 1) )
+       ALLOCATE( ch_xr(1:SIZE( pmc_parent_for_child ) - 1) )
+       ALLOCATE( ch_ys(1:SIZE( pmc_parent_for_child ) - 1) )
+       ALLOCATE( ch_yn(1:SIZE( pmc_parent_for_child ) - 1) )
     ENDIF
 
 !
 !-- Get coordinates from all children
-    DO  m = 1, SIZE( pmc_server_for_client ) - 1
-
-       client_id = pmc_server_for_client(m)
+    DO  m = 1, SIZE( pmc_parent_for_child ) - 1
+
+       child_id = pmc_parent_for_child(m)
        IF ( myid == 0 )  THEN        
 
-          CALL pmc_recv_from_client( client_id, val,  size(val),  0, 123, ierr )
-          CALL pmc_recv_from_client( client_id, fval, size(fval), 0, 124, ierr )
+          CALL pmc_recv_from_child( child_id, val,  size(val),  0, 123, ierr )
+          CALL pmc_recv_from_child( child_id, fval, size(fval), 0, 124, ierr )
          
           nx_cl = val(1)
@@ -598,5 +604,5 @@
 
 !
-!--       Find the highest client level in the coarse grid for the reduced z
+!--       Find the highest nest level in the coarse grid for the reduced z
 !--       transfer
           DO  k = 1, nz                 
@@ -612,9 +618,9 @@
           ALLOCATE( cl_coord_y(-nbgp:ny_cl+nbgp) )
          
-          CALL pmc_recv_from_client( client_id, cl_coord_x, SIZE( cl_coord_x ),&
+          CALL pmc_recv_from_child( child_id, cl_coord_x, SIZE( cl_coord_x ),   &
                                      0, 11, ierr )
-          CALL pmc_recv_from_client( client_id, cl_coord_y, SIZE( cl_coord_y ),&
+          CALL pmc_recv_from_child( child_id, cl_coord_y, SIZE( cl_coord_y ),   &
                                      0, 12, ierr )
-!          WRITE ( 0, * )  'receive from pmc Client ', client_id, nx_cl, ny_cl
+!          WRITE ( 0, * )  'receive from pmc child ', child_id, nx_cl, ny_cl
          
           define_coarse_grid_real(1) = lower_left_coord_x
@@ -631,14 +637,29 @@
 
 !
-!--       Check that the client domain is completely inside the server domain. 
+!--       Check that the child domain matches parent domain. 
           nomatch = 0
-          xez = ( nbgp + 1 ) * dx 
-          yez = ( nbgp + 1 ) * dy 
-          IF ( ( cl_coord_x(0) < define_coarse_grid_real(1) + xez )       .OR. &
-               ( cl_coord_x(nx_cl+1) > define_coarse_grid_real(5) - xez ) .OR. &
-               ( cl_coord_y(0) < define_coarse_grid_real(2) + yez )       .OR. &
-               ( cl_coord_y(ny_cl+1) > define_coarse_grid_real(6) - yez ) )    &
-          THEN
-             nomatch = 1
+          IF ( nesting_mode == 'vertical' )  THEN
+             right_limit = define_coarse_grid_real(5)
+             north_limit = define_coarse_grid_real(6)
+             IF ( ( cl_coord_x(nx_cl+1) /= right_limit ) .OR.                   &
+                  ( cl_coord_y(ny_cl+1) /= north_limit ) )  THEN
+                nomatch = 1
+             ENDIF
+          ELSE
+          
+!
+!--       Check that the children domain is completely inside the parent domain. 
+             xez = ( nbgp + 1 ) * dx 
+             yez = ( nbgp + 1 ) * dy 
+             left_limit  = lower_left_coord_x + xez
+             right_limit = define_coarse_grid_real(5) - xez
+             south_limit = lower_left_coord_y + yez
+             north_limit = define_coarse_grid_real(6) - yez
+             IF ( ( cl_coord_x(0) < left_limit )        .OR.                    &
+                  ( cl_coord_x(nx_cl+1) > right_limit ) .OR.                    &
+                  ( cl_coord_y(0) < south_limit )       .OR.                    &
+                  ( cl_coord_y(ny_cl+1) > north_limit ) )  THEN
+                nomatch = 1
+             ENDIF
           ENDIF
 
@@ -646,5 +667,5 @@
 !--       Check that parallel nest domains, if any, do not overlap.
           nest_overlap = 0
-          IF ( SIZE( pmc_server_for_client ) - 1 > 0 )  THEN
+          IF ( SIZE( pmc_parent_for_child ) - 1 > 0 )  THEN
              ch_xl(m) = cl_coord_x(-nbgp)
              ch_xr(m) = cl_coord_x(nx_cl+nbgp)
@@ -654,6 +675,8 @@
              IF ( m > 1 )  THEN
                 DO mm = 1, m-1
-                   IF ( ( ch_xl(m) < ch_xr(mm) .OR. ch_xr(m) > ch_xl(mm) ) .AND.  &
-                        ( ch_ys(m) < ch_yn(mm) .OR. ch_yn(m) > ch_ys(mm) ) )  THEN                        
+                   IF ( ( ch_xl(m) < ch_xr(mm) .OR.                             &
+                          ch_xr(m) > ch_xl(mm) )  .AND.                         &
+                        ( ch_ys(m) < ch_yn(mm) .OR.                             &
+                          ch_yn(m) > ch_ys(mm) ) )  THEN                        
                       nest_overlap = 1
                    ENDIF
@@ -667,23 +690,23 @@
 !
 !--       Send coarse grid information to child
-          CALL pmc_send_to_client( client_id, define_coarse_grid_real,         &
-                                   SIZE( define_coarse_grid_real ), 0, 21,     &
+          CALL pmc_send_to_child( child_id, define_coarse_grid_real,            &
+                                   SIZE( define_coarse_grid_real ), 0, 21,      &
                                    ierr )
-          CALL pmc_send_to_client( client_id, define_coarse_grid_int,  3, 0,   &
+          CALL pmc_send_to_child( child_id, define_coarse_grid_int,  3, 0,      &
                                    22, ierr )
 
 !
 !--       Send local grid to child
-          CALL pmc_send_to_client( client_id, coord_x, nx+1+2*nbgp, 0, 24,     &
+          CALL pmc_send_to_child( child_id, coord_x, nx+1+2*nbgp, 0, 24,        &
                                    ierr )
-          CALL pmc_send_to_client( client_id, coord_y, ny+1+2*nbgp, 0, 25,     &
+          CALL pmc_send_to_child( child_id, coord_y, ny+1+2*nbgp, 0, 25,        &
                                    ierr )
 
 !
 !--       Also send the dzu-, dzw-, zu- and zw-arrays here
-          CALL pmc_send_to_client( client_id, dzu, nz_cl+1, 0, 26, ierr )
-          CALL pmc_send_to_client( client_id, dzw, nz_cl+1, 0, 27, ierr )
-          CALL pmc_send_to_client( client_id, zu,  nz_cl+2, 0, 28, ierr )
-          CALL pmc_send_to_client( client_id, zw,  nz_cl+2, 0, 29, ierr )
+          CALL pmc_send_to_child( child_id, dzu, nz_cl+1, 0, 26, ierr )
+          CALL pmc_send_to_child( child_id, dzw, nz_cl+1, 0, 27, ierr )
+          CALL pmc_send_to_child( child_id, zu,  nz_cl+2, 0, 28, ierr )
+          CALL pmc_send_to_child( child_id, zw,  nz_cl+2, 0, 29, ierr )
 
        ENDIF
@@ -691,7 +714,7 @@
        CALL MPI_BCAST( nomatch, 1, MPI_INTEGER, 0, comm2d, ierr )
        IF ( nomatch /= 0 ) THEN
-          WRITE ( message_string, * )  'Error: nested child domain does ',    &
+          WRITE ( message_string, * )  'Error: nested child domain does ',      &
                                        'not fit into its parent domain'
-          CALL message( 'pmc_palm_setup_server', 'PA0425', 3, 2, 0, 6, 0 )
+          CALL message( 'pmci_setup_parent', 'PA0425', 3, 2, 0, 6, 0 )
        ENDIF
   
@@ -700,5 +723,5 @@
           WRITE ( message_string, * )  'Nested parallel child ',    &
                                        'domains overlap'
-          CALL message( 'pmc_palm_setup_server', 'PA0426', 3, 2, 0, 6, 0 )
+          CALL message( 'pmci_setup_parent', 'PA0426', 3, 2, 0, 6, 0 )
        ENDIF
       
@@ -710,15 +733,15 @@
 
 !
-!--    Include couple arrays into server content
+!--    Include couple arrays into parent content
 !--    TO_DO: Klaus: please give a more meaningful comment
        CALL pmc_s_clear_next_array_list
-       DO  WHILE ( pmc_s_getnextarray( client_id, myname ) )
-          CALL pmci_set_array_pointer( myname, client_id = client_id,          &
+       DO  WHILE ( pmc_s_getnextarray( child_id, myname ) )
+          CALL pmci_set_array_pointer( myname, child_id = child_id,             &
                                        nz_cl = nz_cl )
        ENDDO
-       CALL pmc_s_setind_and_allocmem( client_id )
+       CALL pmc_s_setind_and_allocmem( child_id )
     ENDDO
 
-    IF ( ( SIZE( pmc_server_for_client ) - 1 > 0 ) .AND. myid == 0 )  THEN 
+    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) .AND. myid == 0 )  THEN 
        DEALLOCATE( ch_xl )
        DEALLOCATE( ch_xr )
@@ -747,5 +770,5 @@
        INTEGER(iwp) ::  px                 !:
        INTEGER(iwp) ::  py                 !:
-       INTEGER(iwp) ::  server_pe          !:
+       INTEGER(iwp) ::  parent_pe          !:
 
        INTEGER(iwp), DIMENSION(2) ::  scoord             !:
@@ -757,8 +780,8 @@
        IF ( myid == 0 )  THEN
 !--       TO_DO: Klaus: give more specific comment what size_of_array stands for
-          CALL pmc_recv_from_client( client_id, size_of_array, 2, 0, 40, ierr )
+          CALL pmc_recv_from_child( child_id, size_of_array, 2, 0, 40, ierr )
           ALLOCATE( coarse_bound_all(size_of_array(1),size_of_array(2)) )
-          CALL pmc_recv_from_client( client_id, coarse_bound_all,              &
-                                     SIZE( coarse_bound_all ), 0, 41, ierr )
+          CALL pmc_recv_from_child( child_id, coarse_bound_all,                 &
+                                    SIZE( coarse_bound_all ), 0, 41, ierr )
 
 !
@@ -783,11 +806,11 @@
           ic  = 0
 !
-!--       Loop over all client PEs
+!--       Loop over all children PEs
           DO  k = 1, size_of_array(2)
 !
-!--          Area along y required by actual client PE
+!--          Area along y required by actual child PE
              DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)
 !
-!--             Area along x required by actual client PE
+!--             Area along x required by actual child PE
                 DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)
 
@@ -796,25 +819,25 @@
                    scoord(1) = px
                    scoord(2) = py
-                   CALL MPI_CART_RANK( comm2d, scoord, server_pe, ierr )
+                   CALL MPI_CART_RANK( comm2d, scoord, parent_pe, ierr )
                   
                    ic = ic + 1
 !
-!--                First index in server array
+!--                First index in parent array
                    index_list(1,ic) = i - ( px * nrx ) + 1 + nbgp
 !
-!--                Second index in server array
+!--                Second index in parent array
                    index_list(2,ic) = j - ( py * nry ) + 1 + nbgp
 !
-!--                x index of client coarse grid
+!--                x index of child coarse grid
                    index_list(3,ic) = i - coarse_bound_all(1,k) + 1
 !
-!--                y index of client coarse grid
+!--                y index of child coarse grid
                    index_list(4,ic) = j - coarse_bound_all(3,k) + 1
 !
-!--                PE number of client
+!--                PE number of child
                    index_list(5,ic) = k - 1
 !
-!--                PE number of server
-                   index_list(6,ic) = server_pe
+!--                PE number of parent
+                   index_list(6,ic) = parent_pe
 
                 ENDDO
@@ -823,5 +846,5 @@
 !
 !--       TO_DO: Klaus: comment what is done here
-          CALL pmc_s_set_2d_index_list( client_id, index_list(:,1:ic) )
+          CALL pmc_s_set_2d_index_list( child_id, index_list(:,1:ic) )
 
        ELSE
@@ -829,5 +852,5 @@
 !--       TO_DO: Klaus: comment why this dummy allocation is required
           ALLOCATE( index_list(6,1) )
-          CALL pmc_s_set_2d_index_list( client_id, index_list )
+          CALL pmc_s_set_2d_index_list( child_id, index_list )
        ENDIF
 
@@ -837,9 +860,9 @@
 
 #endif
- END SUBROUTINE pmci_setup_server
-
-
-
- SUBROUTINE pmci_setup_client
+ END SUBROUTINE pmci_setup_parent
+
+
+
+ SUBROUTINE pmci_setup_child
 
 #if defined( __parallel )
@@ -867,16 +890,16 @@
 !
 !-- TO_DO: describe what is happening in this if-clause
-!-- Root Model does not have Server and is not a client
+!-- Root model does not have a parent and is not a child
     IF ( .NOT. pmc_is_rootmodel() )  THEN
 
-       CALL pmc_clientinit
+       CALL pmc_childinit
 !
 !--    Here AND ONLY HERE the arrays are defined, which actualy will be
-!--    exchanged between client and server.
+!--    exchanged between child and parent.
 !--    If a variable is removed, it only has to be removed from here.
 !--    Please check, if the arrays are in the list of POSSIBLE exchange arrays
 !--    in subroutines:
-!--    pmci_set_array_pointer (for server arrays)
-!--    pmci_create_client_arrays (for client arrays)
+!--    pmci_set_array_pointer (for parent arrays)
+!--    pmci_create_child_arrays (for child arrays)
        CALL pmc_set_dataarray_name( 'coarse', 'u'  ,'fine', 'u',  ierr )
        CALL pmc_set_dataarray_name( 'coarse', 'v'  ,'fine', 'v',  ierr )
@@ -893,5 +916,5 @@
 
 !
-!--    Send grid to server
+!--    Send grid to parent
        val(1)  = nx
        val(2)  = ny
@@ -903,18 +926,18 @@
        IF ( myid == 0 )  THEN
 
-          CALL pmc_send_to_server( val, SIZE( val ), 0, 123, ierr )
-          CALL pmc_send_to_server( fval, SIZE( fval ), 0, 124, ierr )
-          CALL pmc_send_to_server( coord_x, nx + 1 + 2 * nbgp, 0, 11, ierr )
-          CALL pmc_send_to_server( coord_y, ny + 1 + 2 * nbgp, 0, 12, ierr )
+          CALL pmc_send_to_parent( val, SIZE( val ), 0, 123, ierr )
+          CALL pmc_send_to_parent( fval, SIZE( fval ), 0, 124, ierr )
+          CALL pmc_send_to_parent( coord_x, nx + 1 + 2 * nbgp, 0, 11, ierr )
+          CALL pmc_send_to_parent( coord_y, ny + 1 + 2 * nbgp, 0, 12, ierr )
 
 !
 !--       Receive Coarse grid information.
 !--       TO_DO: find shorter and more meaningful name for  define_coarse_grid_real
-          CALL pmc_recv_from_server( define_coarse_grid_real,                  &
+          CALL pmc_recv_from_parent( define_coarse_grid_real,                  &
                                      SIZE(define_coarse_grid_real), 0, 21, ierr )
-          CALL pmc_recv_from_server( define_coarse_grid_int,  3, 0, 22, ierr )
+          CALL pmc_recv_from_parent( define_coarse_grid_int,  3, 0, 22, ierr )
 !
 !--        Debug-printouts - keep them
-!          WRITE(0,*) 'Coarse grid from Server '
+!          WRITE(0,*) 'Coarse grid from parent '
 !          WRITE(0,*) 'startx_tot    = ',define_coarse_grid_real(1)
 !          WRITE(0,*) 'starty_tot    = ',define_coarse_grid_real(2)
@@ -929,5 +952,5 @@
        ENDIF
 
-       CALL MPI_BCAST( define_coarse_grid_real, SIZE(define_coarse_grid_real), &
+       CALL MPI_BCAST( define_coarse_grid_real, SIZE(define_coarse_grid_real),  &
                        MPI_REAL, 0, comm2d, ierr )
        CALL MPI_BCAST( define_coarse_grid_int, 3, MPI_INTEGER, 0, comm2d, ierr )
@@ -941,5 +964,5 @@
 
 !
-!--    Get server coordinates on coarse grid
+!--    Get parent coordinates on coarse grid
        ALLOCATE( cg%coord_x(-nbgp:cg%nx+nbgp) )
        ALLOCATE( cg%coord_y(-nbgp:cg%ny+nbgp) )
@@ -951,13 +974,13 @@
 
 !
-!--    Get coarse grid coordinates and vales of the z-direction from server
+!--    Get coarse grid coordinates and values of the z-direction from the parent
        IF ( myid == 0)  THEN
 
-          CALL pmc_recv_from_server( cg%coord_x, cg%nx+1+2*nbgp, 0, 24, ierr )
-          CALL pmc_recv_from_server( cg%coord_y, cg%ny+1+2*nbgp, 0, 25, ierr )
-          CALL pmc_recv_from_server( cg%dzu, cg%nz + 1, 0, 26, ierr )
-          CALL pmc_recv_from_server( cg%dzw, cg%nz + 1, 0, 27, ierr )
-          CALL pmc_recv_from_server( cg%zu, cg%nz + 2, 0, 28, ierr )
-          CALL pmc_recv_from_server( cg%zw, cg%nz + 2, 0, 29, ierr )
+          CALL pmc_recv_from_parent( cg%coord_x, cg%nx+1+2*nbgp, 0, 24, ierr )
+          CALL pmc_recv_from_parent( cg%coord_y, cg%ny+1+2*nbgp, 0, 25, ierr )
+          CALL pmc_recv_from_parent( cg%dzu, cg%nz + 1, 0, 26, ierr )
+          CALL pmc_recv_from_parent( cg%dzw, cg%nz + 1, 0, 27, ierr )
+          CALL pmc_recv_from_parent( cg%zu, cg%nz + 2, 0, 28, ierr )
+          CALL pmc_recv_from_parent( cg%zw, cg%nz + 2, 0, 29, ierr )
 
        ENDIF
